package Prism.benchmark;

import Prism.core.*;
import Prism.extensions.port.ExtensiblePort;
import Prism.extensions.port.distribution.SocketDistribution;
import java.io.*;

/**
 * @author Sam
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DistBenchUseScenario 
{
	static public void main(String argv[]) 
	{
				int numberOfComps, messageCount, queueSize,threadCount, numberOfArchs, senderPortStart, numOfThisArch=0;
				String senderIP, mode, scenario="";
				numberOfComps=Integer.valueOf(argv[0]).intValue();
				messageCount=Integer.valueOf(argv[1]).intValue();							
				senderIP = argv[2];
				senderPortStart = Integer.valueOf(argv[3]).intValue();
				queueSize=150000;
				threadCount=10;		
				numberOfArchs = Integer.valueOf(argv[5]).intValue();
				if (argv[4].equalsIgnoreCase("sender"))
					mode = "sender";
				else
				{
					mode = "receiver";
					numOfThisArch = Integer.valueOf(argv[7]).intValue();
				}
				scenario = argv[6];
					
				Runtime rt = Runtime.getRuntime();
				System.gc();
				long initMemory1 = rt.freeMemory();
				System.out.println("Initial memory " + initMemory1);
				long totalMemory1 = rt.totalMemory();
				System.out.println("Initial total memory " + totalMemory1);

				//-----------------------------------
				// Architecture initialization begins
				//-----------------------------------     
				
                FIFOScheduler sched = new FIFOScheduler(queueSize);
                Scaffold scaff = new Scaffold();
                RRobinDispatcher disp = new RRobinDispatcher(sched, threadCount);
                scaff.dispatcher=disp;
                scaff.scheduler=sched;
                Architecture arch = new Architecture("Bottom_Arch");                
                arch.scaffold=scaff;
                
                Component[] comps = new Component[numberOfComps];
                AbstractImplementation[] compsImpls = new AbstractImplementation[numberOfComps];      
                ExtensiblePort [] topCompsExtPorts = null;
                if (mode.equalsIgnoreCase("sender"))
                {
                	for (int i=0; i< numberOfComps; i++)
                	{		                                
		                compsImpls[i] = new BottomImpl(messageCount,numberOfComps, numberOfArchs);
		                comps[i] = new Component("Bottom_Comp", compsImpls[i]);
		                comps[i].scaffold=scaff;                
						arch.add(comps[i]);
                	}
					if (scenario.equalsIgnoreCase("noConnMultPorts"))
					{
						ExtensiblePort [] compsExtPorts = new ExtensiblePort[numberOfComps*numberOfArchs];
						for (int i=0; i< numberOfComps; i++)
							for (int j=0; j< (numberOfComps*numberOfArchs); j++)
							{								
						        compsExtPorts[j] = new ExtensiblePort ("Ext_Port", PrismConstants.REQUEST);		    	
						    	SocketDistribution sd=new SocketDistribution(compsExtPorts[j], (i*numberOfComps*numberOfArchs)+senderPortStart+j);        	
						    	compsExtPorts[j].addDistributionModule(sd);
						    	compsExtPorts[j].scaffold = scaff;
								comps[i].addCompPort(compsExtPorts[j]);
								arch.add(compsExtPorts[j]);
							}
					}
					else if (scenario.equalsIgnoreCase("noConnSinglePort"))
					{
						ExtensiblePort [] compsExtPorts = new ExtensiblePort[numberOfComps];
						for (int i=0; i< numberOfComps; i++)
						{
					        compsExtPorts[i] = new ExtensiblePort ("Ext_Port", PrismConstants.REQUEST);		    	
					    	SocketDistribution sd=new SocketDistribution(compsExtPorts[i], senderPortStart+i);        	
					    	compsExtPorts[i].addDistributionModule(sd);
					    	compsExtPorts[i].scaffold = scaff;
							comps[i].addCompPort(compsExtPorts[i]);
							arch.add(compsExtPorts[i]);
						}
					}										
					if (scenario.equalsIgnoreCase("withConnMultPorts"))
					{
						Connector conn = new Connector("conn");
						conn.scaffold =scaff;
						arch.add(conn);
						Port [] compPorts = new Port[numberOfComps];
						Port[] connPorts = new Port[numberOfComps];
						for (int k=0; k<numberOfComps; k++)
						{
							compPorts[k] = new Port("Comp_Port", PrismConstants.REQUEST);
							connPorts[k] = new Port("Conn_Port", PrismConstants.REPLY);
							comps[k].addCompPort(compPorts[k]);
							conn.addConnPort(connPorts[k]);
							arch.add(compPorts[k]);
							arch.add(connPorts[k]);
							arch.weld(compPorts[k],connPorts[k]);
						}
						ExtensiblePort[] connExtPorts = new ExtensiblePort[numberOfComps*numberOfArchs];
						for (int j=0; j< (numberOfComps*numberOfArchs); j++)
						{
							connExtPorts[j] = new ExtensiblePort("Ext_Port", PrismConstants.REQUEST); 
							SocketDistribution sd = new SocketDistribution(connExtPorts[j], senderPortStart+j);	
					    	connExtPorts[j].addDistributionModule(sd);
					    	connExtPorts[j].scaffold = scaff;
							conn.addConnPort(connExtPorts[j]);					
		                    arch.add(connExtPorts[j]);
						}
					}
					else if (scenario.equalsIgnoreCase("withConnSinglePort") || scenario.equalsIgnoreCase("withConnOnAllSinglePort"))
					{
						Connector conn = new Connector("conn");						
						conn.scaffold =scaff;			
						arch.add(conn);
						Port [] compPorts = new Port[numberOfComps];
						Port[] connPorts = new Port[numberOfComps];
						for (int k=0; k<numberOfComps; k++)
						{
							compPorts[k] = new Port("Comp_Port", PrismConstants.REQUEST);
							connPorts[k] = new Port("Conn_Port", PrismConstants.REPLY);
							comps[k].addCompPort(compPorts[k]);
							conn.addConnPort(connPorts[k]);
							arch.weld(compPorts[k],connPorts[k]);
						}						
						ExtensiblePort connExtPort = new ExtensiblePort("Ext_Port", PrismConstants.REQUEST);
						SocketDistribution sd = new SocketDistribution(connExtPort, senderPortStart);	
				    	connExtPort.addDistributionModule(sd);
				    	connExtPort.scaffold = scaff;
						conn.addConnPort(connExtPort);					
	                    arch.add(connExtPort);						
					}                      									
                }
                else if (mode.equalsIgnoreCase("receiver"))
                {  
                	if (scenario.equalsIgnoreCase("withConnOnAllSinglePort"))
                	{
						for(int i=0;i < numberOfComps; i++)
						{
							compsImpls[i] = new TopImpl(messageCount);
							comps[i] = new Component("Top_Comp "+(i+1), compsImpls[i]);
							comps[i].scaffold =scaff;
		                    arch.add(comps[i]);	   
						}
                	}
                	else
                	{
	                	topCompsExtPorts = new ExtensiblePort[numberOfComps];
						for(int i=0;i < numberOfComps; i++)
						{
							compsImpls[i] = new TopImpl(messageCount);
							comps[i] = new Component("Top_Comp "+(i+1), compsImpls[i]);
							comps[i].scaffold =scaff;
		                    arch.add(comps[i]);	   	                    
							topCompsExtPorts[i] = new ExtensiblePort("Top_Comp_Port", PrismConstants.REPLY);
							SocketDistribution sd = new SocketDistribution(topCompsExtPorts[i]);	
					    	topCompsExtPorts[i].addDistributionModule(sd);
					    	topCompsExtPorts[i].scaffold = scaff;
							comps[i].addCompPort(topCompsExtPorts[i]);					
		                    arch.add(topCompsExtPorts[i]);		                    
						}
                	}
                }
		
				//-----------------------------------
				// Architecture execution starts
				//-----------------------------------
				if (mode.equalsIgnoreCase("sender"))
				{
					disp.start();
					arch.start();				
				}
				if (mode.equalsIgnoreCase("receiver"))
				{
					disp.start();
					arch.start();	
					if (scenario.equalsIgnoreCase("noConnMultPorts"))
					{
						for (int i=0; i< numberOfComps; i++)
							for (int j=0; j<numberOfComps; j++)
								topCompsExtPorts[i].connect(senderIP, senderPortStart+i+j*(numberOfComps*numberOfArchs)+numOfThisArch); 								
					}
					else if (scenario.equalsIgnoreCase("noConnSinglePort"))
					{
						for (int i=0; i< numberOfComps; i++)
							for (int j=0; j< numberOfComps; j++)
							topCompsExtPorts[i].connect(senderIP, senderPortStart+j); 														
					}
					else if (scenario.equalsIgnoreCase("withConnMultPorts"))
					{
						for (int i=0; i< numberOfComps; i++)
								topCompsExtPorts[i].connect(senderIP, senderPortStart+i+numOfThisArch*numberOfComps); 														
					}
					else if (scenario.equalsIgnoreCase("withConnSinglePort"))
					{
						for (int i=0; i< numberOfComps; i++)
							topCompsExtPorts[i].connect(senderIP, senderPortStart); 							
					}
					else if (scenario.equalsIgnoreCase("withConnOnAllSinglePort"))
					{
						System.out.println("got here");
						Connector conn = new Connector("conn");						
						conn.scaffold =scaff;			
						arch.add(conn);
						Port [] compPorts = new Port[numberOfComps];
						Port[] connPorts = new Port[numberOfComps];
						for (int k=0; k<numberOfComps; k++)
						{
							compPorts[k] = new Port("Comp_Port", PrismConstants.REPLY);
							connPorts[k] = new Port("Conn_Port", PrismConstants.REQUEST);
							comps[k].addCompPort(compPorts[k]);
							conn.addConnPort(connPorts[k]);
							arch.weld(compPorts[k],connPorts[k]);
						}	
						ExtensiblePort connExtPort = new ExtensiblePort("Ext_Port", PrismConstants.REPLY);
						SocketDistribution sd = new SocketDistribution(connExtPort, senderPortStart);	
				    	connExtPort.addDistributionModule(sd);
				    	connExtPort.scaffold = scaff;
						conn.addConnPort(connExtPort);					
	                    arch.add(connExtPort);																
						connExtPort.connect(senderIP, senderPortStart);							
					}
				}
								
				if (mode.equalsIgnoreCase("sender"))
				{					
				      System.out.println("Tell me when to start by pressing enter "); 
				      //  open up standard input 
				      
				      BufferedReader br = new BufferedReader(new InputStreamReader(System.in)); 
				      //  read the username from the command-line; need to use try/catch with the 
				      //  readLine() method 
				      try { 
				      		br.readLine(); 
				      		
							//-----------------------------------
							// Architecture initialization ends
							//-----------------------------------
							System.gc();
							long remainingMemory = rt.freeMemory();
							System.out.println("Final memory " + remainingMemory);
							long totalMemory2 = rt.totalMemory();
							System.out.println("Final total memory " + totalMemory2);
							System.out.println("Memory used\t" + (initMemory1 - remainingMemory) +" bytes");
							System.out.println("Memory used 2\t" + ((totalMemory2-remainingMemory)-(totalMemory1-initMemory1)) +" bytes");							
							
				      		System.out.println("Starting");
				      		for (int i=0; i<numberOfComps; i++)
				      			((BottomImpl)compsImpls[i]).start2();
				      } catch (IOException ioe) { 
				         System.out.println("IO error trying to read your name!"); 
				         System.exit(1); 
				      } 
				}
				//-----------------------------------
				// Architecture execution ends
				//-----------------------------------
		
	}
}
