package Prism.benchmark;

import Prism.core.*;
import Prism.extensions.port.ExtensiblePort;
import Prism.extensions.port.distribution.SocketDistribution;
import java.io.*;

/**
 * @author Sam
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class DistributionBenchmark 
{
	static public void main(String argv[]) 
	{
				int numberOfComps, messageCount, queueSize,threadCount, numberOfArchs=1;
				String senderIP, senderPort, mode;

				numberOfComps=Integer.valueOf(argv[0]).intValue();
				messageCount=Integer.valueOf(argv[1]).intValue();							
				senderIP = argv[2];
				senderPort = argv[3];
				queueSize=1200000;
				threadCount=10;						
				if (argv[4].equalsIgnoreCase("sender"))
				{
					mode = "sender";
					numberOfArchs = Integer.valueOf(argv[5]).intValue();
					numberOfComps = numberOfComps+1;
				}
				else
					mode = "receiver";

				Runtime rt = Runtime.getRuntime();
				System.gc();
				long initMemory = rt.freeMemory();
				System.out.println("Initial memory " + initMemory);
				long totalMemory = rt.totalMemory();
				System.out.println("Initial total memory " + totalMemory);

				//-----------------------------------
				// Architecture initialization begins
				//-----------------------------------                
                Architecture[] archs = new Architecture[numberOfComps];
                Scaffold[] scaffs = new Scaffold[numberOfComps];
                FIFOScheduler[] scheds = new FIFOScheduler[numberOfComps];
                RRobinDispatcher[] disps = new RRobinDispatcher[numberOfComps];
                Component[] comps = new Component[numberOfComps];
                AbstractImplementation[] compsImpls = new AbstractImplementation[numberOfComps];
                ExtensiblePort[] compsExtPorts = new ExtensiblePort[numberOfComps];         
                	
                int i=0;
                if (mode.equalsIgnoreCase("sender"))
                {
	                scheds[0] = new FIFOScheduler(queueSize);
	                scaffs[0] = new Scaffold();
	                disps[0] = new RRobinDispatcher(scheds[0],threadCount);
	                scaffs[0].dispatcher=disps[0];
	                scaffs[0].scheduler=scheds[0];
	                archs[0] = new Architecture("Bottom_Arch");                
	                archs[0].scaffold=scaffs[0];
	                                
	                compsImpls[0] = new BottomImpl(messageCount,numberOfComps-1, numberOfArchs);
	                comps[0] = new Component("Bottom_Comp", compsImpls[0]);
	                comps[0].scaffold=scaffs[0];                
					archs[0].add(comps[0]);
					
			        compsExtPorts[0] = new ExtensiblePort ("Ext_Port", PrismConstants.REQUEST);		    	
			    	SocketDistribution sd=new SocketDistribution(compsExtPorts[0], Integer.valueOf(senderPort).intValue());        	
			    	compsExtPorts[0].addDistributionModule(sd);
			    	compsExtPorts[0].scaffold = scaffs[0];
					comps[0].addCompPort(compsExtPorts[0]);
					archs[0].add(compsExtPorts[0]);		   
					i++;
                }
                
				for(;i < numberOfComps; i++)
				{
	                scheds[i] = new FIFOScheduler(queueSize);
	                scaffs[i] = new Scaffold();
	                disps[i] = new RRobinDispatcher(scheds[i],threadCount);
	                scaffs[i].dispatcher=disps[i];
	                scaffs[i].scheduler=scheds[i];
	                archs[i] = new Architecture("Top_Arch");                
	                archs[i].scaffold=scaffs[i];
					
					compsImpls[i] = new TopImpl(messageCount);
					comps[i] = new Component("Top_Comp "+(i+1), compsImpls[i]);
					compsExtPorts[i] = new ExtensiblePort("Top_Comp_Port", PrismConstants.REPLY); 
			    	SocketDistribution temp=new SocketDistribution(compsExtPorts[i]);	
			    	compsExtPorts[i].addDistributionModule(temp);
			    	compsExtPorts[i].scaffold = scaffs[i];
					comps[i].addCompPort(compsExtPorts[i]);
					comps[i].scaffold =scaffs[i];
                    archs[i].add(comps[i]);
                    archs[i].add(compsExtPorts[i]);                          
				}					
		
				//-----------------------------------
				// Architecture initialization ends
				//-----------------------------------
				System.gc();
				long remainingMemory = rt.freeMemory();
				System.out.println("Final memory " + remainingMemory);
				totalMemory = rt.totalMemory();
				System.out.println("Final total memory " + totalMemory);
				System.out.println("Memory used\t" + (initMemory - remainingMemory) +" bytes");
		
				//-----------------------------------
				// Architecture execution starts
				//-----------------------------------
				int k=0;
				if (mode.equalsIgnoreCase("sender"))
				{
					disps[0].start();
					archs[0].start();
					k++;
				}
				for (int j=numberOfComps-1; j>=k; j--)
				{
					disps[j].start();
					archs[j].start();	
                    compsExtPorts[j].connect(senderIP,Integer.valueOf(senderPort).intValue()); 					
				}
				
				if (mode.equalsIgnoreCase("sender"))
				{
				      System.out.println("Tell me when to start by pressing enter "); 
				      //  open up standard input 
				      
				      BufferedReader br = new BufferedReader(new InputStreamReader(System.in)); 
				      //  read the username from the command-line; need to use try/catch with the 
				      //  readLine() method 
				      try { 
				      		br.readLine(); 
				      		System.out.println("Starting");
							((BottomImpl)compsImpls[0]).start2();
				      } catch (IOException ioe) { 
				         System.out.println("IO error trying to read your name!"); 
				         System.exit(1); 
				      } 
				}
				//-----------------------------------
				// Architecture execution ends
				//-----------------------------------
		
	}
}
