package Prism.benchmark;

import Prism.core.*;
import Prism.extensions.port.ExtensiblePort;
import Prism.extensions.port.distribution.SocketDistribution;

import java.io.*;

public class SimpleClientPrismDistributionTest {

	public static void main(String[] args) 
	{
		FIFOScheduler sched = new FIFOScheduler(100);
		Scaffold s = new Scaffold();
		RRobinDispatcher disp = new RRobinDispatcher(sched, 10);
		s.dispatcher=disp;
		s.scheduler=sched;
										
		Architecture arch = new Architecture("Demo1");
		arch.scaffold=s;

        ExtensiblePort ep = new ExtensiblePort ("ep", PrismConstants.REQUEST);   
		SocketDistribution sd=new SocketDistribution(ep);    
		ep.addDistributionModule(sd);                
        ep.scaffold = s;

        BottomImpl bImpl = new BottomImpl(1000, 1, 1);
		Component bComp = new Component("B", bImpl);
		bComp.scaffold=s;
		bComp.addCompPort(ep);
		
		arch.add(bComp);
        arch.add(ep);

		disp.start();
		arch.start();
                
        ep.connect("localhost", 2601);
        bImpl.start2();

	}
}
