package Prism.benchmark;

import Prism.core.Architecture;
import Prism.core.Component;
import Prism.core.FIFOScheduler;
import Prism.core.PrismConstants;
import Prism.core.RRobinDispatcher;
import Prism.core.Scaffold;
import Prism.extensions.port.ExtensiblePort;
import Prism.extensions.port.distribution.SocketDistribution;

public class SimpleServerPrismDistributionTest {

	public static void main(String[] args) 
	{
		FIFOScheduler sched = new FIFOScheduler(100);
		Scaffold s = new Scaffold();
		RRobinDispatcher disp = new RRobinDispatcher(sched, 10);
		s.dispatcher=disp;
		s.scheduler=sched;
										
		Architecture arch = new Architecture("Demo1");
		arch.scaffold=s;

        ExtensiblePort ep = new ExtensiblePort ("ep", PrismConstants.REPLY);        
		SocketDistribution sd=new SocketDistribution(ep, 2601);
		ep.addDistributionModule(sd);                
        ep.scaffold = s;

        TopImpl tImpl = new TopImpl(1000);
		Component tComp = new Component("T", tImpl);
		tComp.scaffold=s;
		tComp.addCompPort(ep);
		
		arch.add(tComp);
        arch.add(ep);

		disp.start();
		arch.start();
                
        //ep.connect("localhost", 2601);

	}
}
