package Prism.extensions.port.distribution;

import Prism.core.*;
import java.io.*;
import java.net.*;

/**
 *Connection object used by the SocketDistribution to connect.
 */ 

public abstract class AbstractConnection     //extends Brick implements IPortNames
{
	protected AbstractDistribution parent;
    
    /**
     * Socket belonging to this connection
     */
    protected Socket socket;

	public InetAddress getHost()
	{
		return socket.getInetAddress();
	}
	public int getPort()
	{
		return socket.getPort();
	}

    public AbstractDistribution getParentDistribution ()
    {
            return parent;
    }

	public abstract void writeEvent(Object eventObject);
        
 	public abstract void readEvent(Object eventObject);        

    public abstract void close();
    	
	public abstract void teardown();
}



