package Prism.test;

import Prism.core.*;
import Prism.extensions.port.distribution.*;
import java.io.*;
import java.util.Vector;

public class ComponentDeployer extends Component
{
	Vector commandList = new Vector();
	int commandIdx = 0;
	/**
    * This constructor calls on the <code>Brick(String)</code> constructor.
    *
    * @param name	String: the name of this component object. 
    */
   public ComponentDeployer (String name)
   {
	   super(name);
	   buildCommands();
   }
   
   public void buildCommands()
   {
   		File dllFile = new File("AdditionDLL.dll");
   		Event n= new Event(String.valueOf(PrismConstants.CMD_RECEIVE_COMP));
   		n.addParameter(String.valueOf(PrismConstants.UNICAST_DST_IP), "192.168.1.2");
   		n.addParameter(String.valueOf(PrismConstants.DLL_FILE), dllFile);
   		n.eventType = PrismConstants.REPLY;
   		commandList.addElement(n);
   		
   		n = new Event(String.valueOf(PrismConstants.CMD_INSTAN_COMP));
		n.addParameter(String.valueOf(PrismConstants.UNICAST_DST_IP), "192.168.1.2");
		n.addParameter(String.valueOf(PrismConstants.COMP_NAME), new Integer(301));
		n.addParameter(String.valueOf(PrismConstants.COMP_FILE_NAME), "Addition");
		n.eventType = PrismConstants.REPLY;
		commandList.addElement(n);
		
		dllFile = new File("SubtractionDLL.dll");
   		n= new Event(String.valueOf(PrismConstants.CMD_RECEIVE_COMP));
   		n.addParameter(String.valueOf(PrismConstants.UNICAST_DST_IP), "192.168.1.2");
   		n.addParameter(String.valueOf(PrismConstants.DLL_FILE), dllFile);
   		n.eventType = PrismConstants.REPLY;
   		commandList.addElement(n);
   		
   		n = new Event(String.valueOf(PrismConstants.CMD_INSTAN_COMP));
		n.addParameter(String.valueOf(PrismConstants.UNICAST_DST_IP), "192.168.1.2");
		n.addParameter(String.valueOf(PrismConstants.COMP_NAME), new Integer(302));
		n.addParameter(String.valueOf(PrismConstants.COMP_FILE_NAME), "Subtraction");
		n.eventType = PrismConstants.REPLY;
		commandList.addElement(n);
		
		n = new Event(String.valueOf(PrismConstants.CMD_INSTAN_CONN));
		n.addParameter(String.valueOf(PrismConstants.UNICAST_DST_IP), "192.168.1.2");
		n.addParameter(String.valueOf(PrismConstants.CONN_NAME), new Integer(306));
		n.eventType = PrismConstants.REPLY;
		commandList.addElement(n);
		
		n = new Event(String.valueOf(PrismConstants.CMD_INSTAN_PORT));
		n.addParameter(String.valueOf(PrismConstants.UNICAST_DST_IP), "192.168.1.2");
		n.addParameter(String.valueOf(PrismConstants.CREATE_BASIC_REPLY_PORT), new Integer(309));
		n.addParameter(String.valueOf(PrismConstants.PARENT_COMP), new Integer(301));
		n.eventType = PrismConstants.REPLY;
		commandList.addElement(n);
		
		n = new Event(String.valueOf(PrismConstants.CMD_INSTAN_PORT));
		n.addParameter(String.valueOf(PrismConstants.UNICAST_DST_IP), "192.168.1.2");
		n.addParameter(String.valueOf(PrismConstants.CREATE_BASIC_REQUEST_PORT), new Integer(308));
		n.addParameter(String.valueOf(PrismConstants.PARENT_CONN), new Integer(306));
		n.eventType = PrismConstants.REPLY;
		commandList.addElement(n);
		
		n = new Event(String.valueOf(PrismConstants.CMD_INSTAN_PORT));
		n.addParameter(String.valueOf(PrismConstants.UNICAST_DST_IP), "192.168.1.2");
		n.addParameter(String.valueOf(PrismConstants.CREATE_BASIC_REPLY_PORT), new Integer(314));
		n.addParameter(String.valueOf(PrismConstants.PARENT_CONN), new Integer(306));
		n.eventType = PrismConstants.REPLY;
		commandList.addElement(n);
		
		n = new Event(String.valueOf(PrismConstants.CMD_INSTAN_PORT));
		n.addParameter(String.valueOf(PrismConstants.UNICAST_DST_IP), "192.168.1.2");
		n.addParameter(String.valueOf(PrismConstants.CREATE_BASIC_REQUEST_PORT), new Integer(313));
		n.addParameter(String.valueOf(PrismConstants.PARENT_COMP), new Integer(304));
		n.eventType = PrismConstants.REPLY;
		commandList.addElement(n);
		
		n = new Event(String.valueOf(PrismConstants.CMD_WELD_PORT));
		n.addParameter(String.valueOf(PrismConstants.UNICAST_DST_IP), "192.168.1.2");
		n.addParameter(String.valueOf(PrismConstants.REQ_PORT_NAME), new Integer(308));
		n.addParameter(String.valueOf(PrismConstants.REP_PORT_NAME), new Integer(309));
		n.eventType = PrismConstants.REPLY;
		commandList.addElement(n);
		
		n = new Event(String.valueOf(PrismConstants.CMD_WELD_PORT));
		n.addParameter(String.valueOf(PrismConstants.UNICAST_DST_IP), "192.168.1.2");
		n.addParameter(String.valueOf(PrismConstants.REQ_PORT_NAME), new Integer(313));
		n.addParameter(String.valueOf(PrismConstants.REP_PORT_NAME), new Integer(314));
		n.eventType = PrismConstants.REPLY;
		commandList.addElement(n);
		
		n = new Event(String.valueOf(PrismConstants.CMD_ARCH_START));
		n.addParameter(String.valueOf(PrismConstants.UNICAST_DST_IP), "192.168.1.2");
		n.eventType = PrismConstants.REPLY;
		commandList.addElement(n);
   }
	public void handle(Event r)
	{
		
		if (r.name.equals(String.valueOf(PrismConstants.DEPLOYMENT_REQ)))
		{
			commandIdx = 0;
			send((Event)commandList.elementAt(commandIdx++));
		}
		else if(r.name.equals(String.valueOf(PrismConstants.DEPLOYMENT_ACK)))
		{
			if(commandIdx >= commandList.size()) {
				commandIdx = 0;
				return;
			}
			send((Event)commandList.elementAt(commandIdx++));
		}
	}
}
