
package Prism.test.deployment;

import Prism.core.*;
import Prism.extensions.component.*;
import Prism.extensions.component.deployment.*;
import Prism.extensions.port.*;
import Prism.extensions.port.distribution.*;

public class Skeleton 
{
	static public void main(String argv[]) 
	{		
		FIFOScheduler sched = new FIFOScheduler(150);
		Scaffold s = new Scaffold();
		RRobinDispatcher disp = new RRobinDispatcher(sched, 10);
		s.dispatcher=disp;
		s.scheduler=sched;
	
		Architecture arch = new Architecture("Skeleton");
		arch.scaffold=s;
	
		AbstractImplementation admin = new Admin(argv[0]);			
		ExtensibleComponent extComp = new ExtensibleComponent("Admin", PrismConstants.P2P_COMP, admin, arch);			
		extComp.scaffold = s;
		arch.add(extComp);
	
        ExtensiblePort ep = new ExtensiblePort ("ep", PrismConstants.REQUEST);
        SocketDistribution sd = new SocketDistribution(ep);
		ep.addDistributionModule(sd);      
		ep.scaffold = s;
		arch.add(ep);
		
		extComp.addCompPort(ep);
			           
		disp.start();			
		arch.start();	
		ep.connect(argv[0], (Integer.valueOf(argv[1])).intValue());
		
	}
}